<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUrunEtiket ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfUrunEtiket
 * @subpackage Arrays
 */
class ArrayOfUrunEtiket extends AbstractStructArrayBase
{
    /**
     * The UrunEtiket
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UrunEtiket[]
     */
    public $UrunEtiket;
    /**
     * Constructor method for ArrayOfUrunEtiket
     * @uses ArrayOfUrunEtiket::setUrunEtiket()
     * @param \StructType\UrunEtiket[] $urunEtiket
     */
    public function __construct(array $urunEtiket = array())
    {
        $this
            ->setUrunEtiket($urunEtiket);
    }
    /**
     * Get UrunEtiket value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UrunEtiket[]|null
     */
    public function getUrunEtiket()
    {
        return isset($this->UrunEtiket) ? $this->UrunEtiket : null;
    }
    /**
     * This method is responsible for validating the values passed to the setUrunEtiket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUrunEtiket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUrunEtiketForArrayConstraintsFromSetUrunEtiket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfUrunEtiketUrunEtiketItem) {
            // validation for constraint: itemType
            if (!$arrayOfUrunEtiketUrunEtiketItem instanceof \StructType\UrunEtiket) {
                $invalidValues[] = is_object($arrayOfUrunEtiketUrunEtiketItem) ? get_class($arrayOfUrunEtiketUrunEtiketItem) : sprintf('%s(%s)', gettype($arrayOfUrunEtiketUrunEtiketItem), var_export($arrayOfUrunEtiketUrunEtiketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UrunEtiket property can only contain items of type \StructType\UrunEtiket, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UrunEtiket value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UrunEtiket[] $urunEtiket
     * @return \ArrayType\ArrayOfUrunEtiket
     */
    public function setUrunEtiket(array $urunEtiket = array())
    {
        // validation for constraint: array
        if ('' !== ($urunEtiketArrayErrorMessage = self::validateUrunEtiketForArrayConstraintsFromSetUrunEtiket($urunEtiket))) {
            throw new \InvalidArgumentException($urunEtiketArrayErrorMessage, __LINE__);
        }
        if (is_null($urunEtiket) || (is_array($urunEtiket) && empty($urunEtiket))) {
            unset($this->UrunEtiket);
        } else {
            $this->UrunEtiket = $urunEtiket;
        }
        return $this;
    }
    /**
     * Add item to UrunEtiket value
     * @throws \InvalidArgumentException
     * @param \StructType\UrunEtiket $item
     * @return \ArrayType\ArrayOfUrunEtiket
     */
    public function addToUrunEtiket(\StructType\UrunEtiket $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UrunEtiket) {
            throw new \InvalidArgumentException(sprintf('The UrunEtiket property can only contain items of type \StructType\UrunEtiket, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UrunEtiket[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UrunEtiket|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UrunEtiket|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UrunEtiket|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UrunEtiket|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UrunEtiket|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UrunEtiket
     */
    public function getAttributeName()
    {
        return 'UrunEtiket';
    }
}
